package com.example.collectionofshortstories.view.createArticle

import androidx.compose.runtime.Composable
import androidx.compose.ui.tooling.preview.Preview
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.collectionofshortstories.domain.untils.Constants
import com.example.collectionofshortstories.model.Article
import com.example.collectionofshortstories.model.Categories
import dagger.hilt.android.lifecycle.HiltViewModel
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.StateFlow
import kotlinx.coroutines.flow.asStateFlow
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext
import javax.inject.Inject

@HiltViewModel
class СreateArticleViewModel @Inject constructor() : ViewModel() {
    private val _categories: MutableStateFlow<List<Categories>> = MutableStateFlow( listOf() )
    val categories: StateFlow<List<Categories>> = _categories.asStateFlow()

    fun GetCategories() {
        viewModelScope.launch {
            withContext(Dispatchers.IO) {
                val updatedCategories = Constants.supabase.from("categories")
                    .select()
                _categories.value = updatedCategories.decodeList<Categories>()
            }
        }
    }

}